> For the complete documentation index, see [llms.txt](https://docs.finpay.id/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.finpay.id/finpay-pg/core-api/credit-card/advance-payment/save-card/transaction-using-stored-card/one-click-payment.md).

# One Click Payment

**One click payment** is a payment model concept that takes convenience to the next level by allowing customers to make purchases with a single click or tap, without the need to go through the traditional payment process. This simplified payment method aims to reduce friction even further and speed up the buying experience for online shoppers.

This is a payment model commonly used for subscription-based services, memberships, utility bills, insurance premiums, and other ongoing or periodic expenses. This service is also known as recurring payment

Recurring payments offer convenience to both customers and businesses. Customers do not need to manually make payments every time a service or subscription is renewed, as the payment is automatically deducted from their credit card number. This saves time and ensures continuity of service. For businesses, recurring payments provide a predictable and regular revenue stream, reducing the need for manual invoicing and follow-ups.

{% hint style="info" %}
INFO

Before doing this process, make sure you have done the [Retrieve Stored Card API](/finpay-pg/core-api/credit-card/advance-payment/save-card/retrieve-stored-card.md) to get the credit card token used for the transaction.
{% endhint %}

| Environment | Method | URL                                                 |
| ----------- | ------ | --------------------------------------------------- |
| Development | POST   | <https://devo.finnet.co.id/pg/payment/card/payment> |
| Production  | POST   | <https://live.finnet.co.id/pg/payment/card/payment> |

### Data Request <a href="#body-request" id="body-request"></a>

| No | Name          | Type                                                      | Mandatory | Min Length | Max Length | Description             |
| -- | ------------- | --------------------------------------------------------- | --------- | ---------- | ---------- | ----------------------- |
| 1  | order         | [Object](/appendix/json-object/order-object.md)           | M         | 1          | 12         | Detail of Order         |
| 2  | customer      | [Object](/appendix/json-object/customer-object.md)        | M         | 1          | 8          | Detail of Customer      |
| 3  | url           | [Object](/appendix/json-object/url-object.md)             | O         | 1          | 4          | Detail of Url           |
| 4  | billing       | [Object](/appendix/json-object/billing-object.md)         | O         | 1          | 1          | Detail of Billing       |
| 5  | shipping      | [Object](/appendix/json-object/shipping-object.md)        | O         | 1          | 4          | Detail of Shipping      |
| 6  | meta          | [Object](/appendix/json-object/meta-object.md)            | O         | 1          | 1          | Detail of MetaData      |
| 7  | card          | [Object](/appendix/json-object/card-object.md)            | M         | 1          | 7          | Detail of Card          |
| 8  | recurring     | [Object](/appendix/json-object/recurring-object.md)       | O         | 1          | 11         | Detail of Recurring     |
| 9  | sourceOfFunds | [Object](/appendix/json-object/source-of-funds-object.md) | O         | 1          | 11         | Detail of SourceOfFunds |
| 10 | device        | [Object](/appendix/json-object/device-object.md)          | O         | 1          | 7          | Detail of Device        |

#### Sample Request <a href="#sample-request" id="sample-request"></a>

```
{
  "customer": {
    "id": "hajar.finnet@gmail.com",
    "email": "hajar.finnet@gmail.com",
    "firstName": "Hajar",
    "lastName": "Ismail",
    "mobilePhone": "+6281286288844"
  },
  "order": {
    "id": "1685522307103",
    "amount": "1000",
    "currency": "IDR",
    "description": "Testing"
  },
  "card": {
    "token": "81b36a850c2e40458bad296f952084b516c919ca717d448722782769b81b9fd9",
    "storedOnFile": "STORED"
  }
}
```

### Data Response <a href="#data-response" id="data-response"></a>

| No | Name            | Type                                                | Mandatory | Min Length | Max Length | Description      |
| -- | --------------- | --------------------------------------------------- | --------- | ---------- | ---------- | ---------------- |
| 1  | responseCode    | [Enum](/appendix/enumeration/response-code-list.md) | M         | 1          | 7          | Response Code    |
| 2  | responseMessage | String                                              | M         | 1          | 500        | Response Message |
| 3  | data            | Object                                              | M         | 1          | 11         | Array of data    |

| No | Name              | Type    | Mandatory | Min Length | Max Length | Description                                                                                                                                                                                         |
| -- | ----------------- | ------- | --------- | ---------- | ---------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| 1  | acquirer          | Object  | C         | 1          | 10         | Acquirer                                                                                                                                                                                            |
| 2  | amount            | Numeric | O         | 1          | 14         | Amount                                                                                                                                                                                              |
| 3  | authorizationCode | String  | O         | 1          | 100        | Authorization Code                                                                                                                                                                                  |
| 4  | currency          | String  | O         | 3          | 3          | Currency                                                                                                                                                                                            |
| 5  | id                | String  | O         | 1          | 40         | ID of Payment                                                                                                                                                                                       |
| 6  | receipt           | String  | O         | 1          | 100        | Receipt                                                                                                                                                                                             |
| 7  | reference         | String  | O         | 1          | 40         | Reference ID                                                                                                                                                                                        |
| 8  | source            | Enum    | O         |            |            | CALL\_CENTRE, CARD\_PRESENT,INTERNET,MAIL\_ORDER,MERCHANT,MOTO,PAYER\_PRESENT,SERVICE\_PROVIDER,TELEPHONE\_ORDER,VOICE\_RESPONSE                                                                    |
| 9  | stan              | Number  | O         | 1          | 6          | Stan                                                                                                                                                                                                |
| 10 | terminal          | String  | O         | 1          | 16         | Transaction Terminal                                                                                                                                                                                |
| 11 | type              | Enum    | O         |            |            | AUTHENTICATION,AUTHORIZATION,AUTHORIZATION\_UPDATE,CAPTURE,CHARGEBACK,DISBURSEMENT,FUNDING,PAYMENT,REFUND,REFUND\_REQUEST,VERIFICATION,VOID\_AUTHORIZATION,VOID\_CAPTURE,VOID\_PAYMENT,VOID\_REFUND |

#### Sample Response <a href="#sample-response" id="sample-response"></a>

```
{
  "responseCode": "2000000",
  "responseMessage": "Success",
  "data": {
    "acquirer": {
      "batch": 20230531,
      "date": "0531",
      "id": "CIMB_S2I",
      "merchantId": "000800910091992",
      "settlementDate": "2023-05-31",
      "timeZone": "+0700",
      "transactionId": "123456789"
    },
    "amount": 1000,
    "authorizationCode": "082941",
    "currency": "IDR",
    "id": "C-46081b76-b4e7-4260-aebc-bdd5368d186d",
    "receipt": "315108082941",
    "reference": "C-46081b76-b4e7-4260-aebc-bdd5368d186d",
    "source": "INTERNET",
    "stan": "83950",
    "terminal": "CIMBIN01",
    "type": "CAPTURE"
  },
  "processingTime": 4.724647045135498
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.finpay.id/finpay-pg/core-api/credit-card/advance-payment/save-card/transaction-using-stored-card/one-click-payment.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
